#include "KMKill.h"

#include "common/KMFolder.h"
#include "common/KMInstance.h"
#include "common/KMLogger.h"

using namespace std;

REGISTER_SUBCOMMAND_DYNCREATE(kill, KMKill)

class KMKill::Private
{
};

KMKill::KMKill()
    : m_dPtr(make_shared<Private>())
{
}

KMKill::~KMKill() { }

int KMKill::despose(int argc, char **argv)
{
    if (argc < 1)
    {
        cout << "INSTANCE or APP must be specified" << endl;
        return -1;
    }

    vector<shared_ptr<KMInstance>> all_instances = KMInstance::getAllInstances();

    for (int i = 1; i < argc; i++)
    {
        bool isValid = false;
        for (const auto &instance : all_instances)
        {
            if (instance->getApp() == string(argv[i]) || instance->getInstanceId() == string(argv[i]))
            {
                if (kill(instance->getChildPid(), SIGKILL) == 0)
                {
                    cout << "\033[1;32m"
                         << "kill " << argv[i] << " ok."
                         << "\033[0m" << endl;
                }
                else
                {
                    cout << "\033[1;31m"
                         << "kill " << argv[i] << " error."
                         << "\033[0m" << endl;
                    continue;
                }
                isValid = true;
            }
        }

        if (!isValid)
        {
            cout << "\033[1;33m" << argv[i] << " is invalid instance or app id." << "\033[0m" << endl;
        }
    }

    return 0;
}