#include "KMPS.h"

#include <iomanip>

#include "common/KMInstance.h"
#include "common/KMLogger.h"

using namespace std;

REGISTER_SUBCOMMAND_DYNCREATE(ps, KMPS)

class KMPS::Private
{
};

KMPS::KMPS()
    : m_dPtr(make_shared<Private>())
{
}

KMPS::~KMPS() { }

int KMPS::despose(int argc, char **argv)
{
    vector<shared_ptr<KMInstance>> allInstance = KMInstance::getAllInstances();
    int instanceMaxLength = 10, pidMaxLength = 5, appMaxLength = 5, runtimeMaxLength = 9;

    for (auto instance : allInstance)
    {
        instanceMaxLength = max(static_cast<int>(instance->getInstanceId().length()) + 2, instanceMaxLength);
        pidMaxLength = max(static_cast<int>(std::to_string(instance->getPid()).length()) + 2, pidMaxLength);
        appMaxLength = max(static_cast<int>(instance->getApp().length()) + 2, appMaxLength);
        runtimeMaxLength = max(static_cast<int>(instance->getRuntime().length()) + 2, runtimeMaxLength);
    }

    cout << "\033[1m" << left << setw(instanceMaxLength) << "instance" << left << setw(pidMaxLength) << "pid" << left << setw(appMaxLength) << "app" << left << setw(runtimeMaxLength) << "runtime"
         << "\033[0m" << endl;

    for (auto instance : allInstance)
    {
        cout << left << setw(instanceMaxLength) << instance->getInstanceId() << left << setw(pidMaxLength) << instance->getPid() << left << setw(appMaxLength) << instance->getApp() << left << setw(runtimeMaxLength) << instance->getRuntime() << endl;
    }

    return 0;
}
